"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestCache = void 0;
const utils_keyvaluecache_1 = require("@apollo/utils.keyvaluecache");
const lodash_1 = __importDefault(require("lodash"));
class RequestCache {
    static self;
    defaultCacheSetting = {
        max: 500,
        // for use with tracking overall storage size
        maxSize: 5000,
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        sizeCalculation: (value, key) => {
            return 1;
        },
        // 30 seconds (in milliseconds)
        ttl: 30 * 1000
    };
    cache;
    constructor() {
        this.cache = new utils_keyvaluecache_1.InMemoryLRUCache(this.defaultCacheSetting);
    }
    static get instance() {
        return this.self || (this.self = new RequestCache());
    }
    async set(id, newId) {
        const oldId = await this.cache.get(id);
        oldId ? this.cache.set(id, JSON.stringify(lodash_1.default.merge(JSON.parse(oldId), newId))) : this.cache.set(id, JSON.stringify(newId));
    }
    async get(id) {
        return JSON.parse(await this.cache.get(id));
    }
}
exports.RequestCache = RequestCache;
//# sourceMappingURL=resolver-cache.js.map